
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Deductible_paymentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const deductible_payments = await db.deductible_payments.create(
            {
                id: data.id || undefined,
        
        payment_code: data.payment_code
        ||
        null
            ,
            
        beneficiary_name: data.beneficiary_name
        ||
        null
            ,
            
        beneficiary_document: data.beneficiary_document
        ||
        null
            ,
            
        amount_paid: data.amount_paid
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await deductible_payments.setDeclaration( data.declaration || null, {
            transaction,
        });
        
        await deductible_payments.setDependent( data.dependent || null, {
            transaction,
        });
        
        await deductible_payments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return deductible_payments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const deductible_paymentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                payment_code: item.payment_code
            ||
            null
            ,
            
                beneficiary_name: item.beneficiary_name
            ||
            null
            ,
            
                beneficiary_document: item.beneficiary_document
            ||
            null
            ,
            
                amount_paid: item.amount_paid
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const deductible_payments = await db.deductible_payments.bulkCreate(deductible_paymentsData, { transaction });

        // For each item created, replace relation files
        

        return deductible_payments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const deductible_payments = await db.deductible_payments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.payment_code !== undefined) updatePayload.payment_code = data.payment_code;
        
        
        if (data.beneficiary_name !== undefined) updatePayload.beneficiary_name = data.beneficiary_name;
        
        
        if (data.beneficiary_document !== undefined) updatePayload.beneficiary_document = data.beneficiary_document;
        
        
        if (data.amount_paid !== undefined) updatePayload.amount_paid = data.amount_paid;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await deductible_payments.update(updatePayload, {transaction});

        
        
        if (data.declaration !== undefined) {
            await deductible_payments.setDeclaration(
              
              data.declaration,
              
              { transaction }
            );
        }
        
        if (data.dependent !== undefined) {
            await deductible_payments.setDependent(
              
              data.dependent,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await deductible_payments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return deductible_payments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const deductible_payments = await db.deductible_payments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of deductible_payments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of deductible_payments) {
                await record.destroy({transaction});
            }
        });


        return deductible_payments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const deductible_payments = await db.deductible_payments.findByPk(id, options);

        await deductible_payments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await deductible_payments.destroy({
            transaction
        });

        return deductible_payments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const deductible_payments = await db.deductible_payments.findOne(
            { where },
            { transaction },
        );

        if (!deductible_payments) {
            return deductible_payments;
        }

        const output = deductible_payments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.declaration = await deductible_payments.getDeclaration({
            transaction
        });
        
        
        output.dependent = await deductible_payments.getDependent({
            transaction
        });
        
        
        output.organizations = await deductible_payments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.declarations,
        as: 'declaration',
        
        where: filter.declaration ? {
          [Op.or]: [
            { id: { [Op.in]: filter.declaration.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.declaration.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.dependents,
        as: 'dependent',
        
        where: filter.dependent ? {
          [Op.or]: [
            { id: { [Op.in]: filter.dependent.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.dependent.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.payment_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'deductible_payments',
                        'payment_code',
                        filter.payment_code,
                    ),
                };
            }
            
            if (filter.beneficiary_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'deductible_payments',
                        'beneficiary_name',
                        filter.beneficiary_name,
                    ),
                };
            }
            
            if (filter.beneficiary_document) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'deductible_payments',
                        'beneficiary_document',
                        filter.beneficiary_document,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'deductible_payments',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.amount_paidRange) {
                const [start, end] = filter.amount_paidRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount_paid: {
                    ...where.amount_paid,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount_paid: {
                    ...where.amount_paid,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.deductible_payments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'deductible_payments',
                        'beneficiary_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.deductible_payments.findAll({
            attributes: [ 'id', 'beneficiary_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['beneficiary_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.beneficiary_name,
        }));
    }

    
};

